# View Change

## View Change Basic

### View Change Basic 1

#### Test Description
Tests for consistency in view changes, when dropping a node from the view and then adding a new one to the view. This test gives the opportunity for nodes to converge with 10 second sleeps, so all servers *should* be consistent before any view changes occur. 

1. Send view containing A, B to nodes A and B
2. c1.PUT(A, a=1)
3. c2.PUT(B, a=2)
4. c1.PUT(B, b=3)
5. c2.PUT(A, c=4)
6. sleep(10), allows convergence for A and B
7. Drop B from the view
8. Add C to the view, update A and C with new view
9. c1.PUT(A, a=5)
10. c2.PUT(C, e=6)
11. sleep(10), allows convergence for A and C
12. c1.GETALL(A) == c2.GETALL(C)

#### Explicit violation
if any writes fail or if the KVS states don't match at the end.

#### Lamport Diagram
![Lamport diagram - View Change Basic](./lamport-view-change-basic-1.jpg)